  $ source "$TESTDIR/helpers.bash"

  $ compile <<EOF
  > @
  > |
  > variable int : a;
  > a := 5;
  > variable int : b;
  > print(:);
  > if (a > 0) then {
  >     :
  > } otherwise {
  > }
  > EOF
  error, line 2: illegal character '@'
  error, line 3: illegal character '|'
  error, line 6, column 0: unexpected keyword 'variable'
  error, line 7, column 10: invalid expression ':'
  no code was generated
  $ ! test -f script.qud

  $ cat script.lst
  01: procedure main {
  02:     @
  03:     |
  04:     variable int : a;
  05:     a := 5;
  06:     variable int : b;
  07:     print(:);
  08:     if (a > 0) then {
  09:         :
  10:     } otherwise {
  11:     }
  12: }
  
  error, line 2: illegal character '@'
  error, line 3: illegal character '|'
  error, line 6, column 0: unexpected keyword 'variable'
  error, line 7, column 10: invalid expression ':'

  $ compile <<EOF
  > variable foo;
  > EOF
  error, line 2, column 17: invalid variable declarations 'foo'
  no code was generated

  $ compile <<EOF
  > variable int : a;
  >          int : a;
  > EOF
  error, line 3: variable a already declared
  no code was generated

  $ compile <<EOF
  > read(a);
  > EOF
  error, line 2: unknown variable: a
  no code was generated

  $ compile <<EOF
  > a := 5;
  > EOF
  error, line 2: unknown variable: a
  no code was generated

  $ compile <<EOF
  > a := ival(3.14);
  > EOF
  error, line 2: unknown variable: a
  no code was generated

  $ compile <<EOF
  > variable int : a;
  >          real : b;
  > a := b;
  > EOF
  error, line 4: cannot implicitly convert real to int: a (use ival)
  no code was generated

  $ compile <<EOF
  > variable int : a;
  >          real : b;
  > a := rval(b);
  > EOF
  error, line 4: no conversion from real to int: a
  no code was generated

  $ compile <<EOF
  > variable real : b;
  > a := rval(b);
  > EOF
  error, line 3: unknown variable: a
  no code was generated

  $ compile <<EOF
  > variable real : a;
  > a := 5 * b;
  > EOF
  error, line 3: unknown variable: b
  no code was generated
