  $ source "$TESTDIR/helpers.bash"

  $ compile <<EOF
  > variable int : a;
  >          real : b;
  > a := 1;
  > b := 2.1;
  > print(a+b);
  > print(b+a);
  > print(a-b);
  > print(b-a);
  > a := 2;
  > b := 4;
  > print(a/b);
  > print(b/a);
  > print(a*b);
  > print(b*a);
  > EOF

  $ qx script.qud
  3.1
  3.1
  -1.1
  1.1
  0.5
  2.0
  8.0
  8.0

  $ compile <<EOF
  > variable int : a;
  >          real : b;
  >          int : c;
  > a := 1;
  > b := 2.1;
  > c := a + b;
  > EOF
  error, line 7: cannot implicitly convert real to int: c (use ival)
  no code was generated
  $ compile <<EOF
  > variable int : a;
  >          int : b;
  >          real : c;
  > a := 1;
  > b := 2;
  > c := a + b;
  > print(c);
  > EOF
  $ qx script.qud
  3.0

  $ compile <<EOF
  > variable int : a;
  >          real : b;
  >          int : c;
  > a := 1;
  > b := 2.1;
  > c := ival(a + b);
  > print(c);
  > EOF
  $ qx script.qud
  3
