  $ source "$TESTDIR/helpers.bash"

  $ compile <<EOF
  > variable int : a;
  > for (a := 0; a < 5; a := a + 1) {
  >     print(a);
  > }
  > EOF
  $ qx script.qud
  0
  1
  2
  3
  4

  $ compile <<EOF
  > variable int : a;
  > for (a := 5; a > 0; a := a - 1) {
  >     print(a);
  > }
  > EOF
  $ qx script.qud
  5
  4
  3
  2
  1

  $ compile <<EOF
  > variable int : a;
  > for (a := 1; a < 10; a := a * 2) {
  >     print(a);
  > }
  > EOF
  $ qx script.qud
  1
  2
  4
  8

  $ compile <<EOF
  > variable int : a;
  > for (a := 10; a > 1; a := a / 2) {
  >     print(a);
  > }
  > EOF
  $ qx script.qud
  10
  5
  2

  $ compile <<EOF
  > variable int : a;
  > for (a := 0; a < 5; a := a + 1) {
  >     print(a);
  >     if (a < 2) then {
  >         print(1);
  >     } otherwise {
  >         print(2);
  >     }
  > }
  > EOF
  $ qx script.qud
  0
  1
  1
  1
  2
  2
  3
  2
  4
  2
